Index: LMDZ5/trunk/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2037)
+++ LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2068)
@@ -442,5 +442,5 @@
   REAL beta_prec_fisrt(klon,klev) ! taux de conv de l'eau cond (fisrt)
   ! RomP <<<
-  
+
   REAL          :: calday
 
@@ -489,6 +489,6 @@
   EXTERNAL fisrtilp  ! schema de condensation a grande echelle (pluie)
   !AA 
-! JBM (3/14) fisrtilp_tr not loaded
-! EXTERNAL fisrtilp_tr ! schema de condensation a grande echelle (pluie)
+  ! JBM (3/14) fisrtilp_tr not loaded
+  ! EXTERNAL fisrtilp_tr ! schema de condensation a grande echelle (pluie)
   !                          ! stockage des coefficients necessaires au
   !                          ! lessivage OFF-LINE et ON-LINE
@@ -542,5 +542,5 @@
 
   !
-!  REAL zxsnow(klon)
+  !  REAL zxsnow(klon)
   REAL zxsnow_dummy(klon)
   !
@@ -636,5 +636,5 @@
   !======================================================================
   !
-  
+
   !
   integer itau_w   ! pas de temps ecriture = itap + itau_phy
@@ -689,7 +689,7 @@
   !
   !IM 280405 BEG
-!  INTEGER nid_bilKPins, nid_bilKPave
-!  SAVE nid_bilKPins, nid_bilKPave
-!  !$OMP THREADPRIVATE(nid_bilKPins, nid_bilKPave)
+  !  INTEGER nid_bilKPins, nid_bilKPave
+  !  SAVE nid_bilKPins, nid_bilKPave
+  !  !$OMP THREADPRIVATE(nid_bilKPins, nid_bilKPave)
   !
   REAL ve_lay(klon,klev) ! transport meri. de l'energie a chaque niveau vert.
@@ -701,5 +701,5 @@
   REAL zsto
   REAL zstophy, zout
- 
+
   real zjulian
   save zjulian
@@ -1588,8 +1588,8 @@
 
      IF (solarlong0<-999.) then
-     ! Generic case with evolvoing season
+        ! Generic case with evolvoing season
         zzz=real(days_elapsed+1)
      ELSE IF (abs(solarlong0-1000.)<1.e-4) then
-     ! Particular case with annual mean insolation
+        ! Particular case with annual mean insolation
         zzz=real(90) ! could be revisited
         IF (read_climoz/=-1) THEN
@@ -1598,5 +1598,5 @@
         ENDIF
      ELSE
-     ! Case where the season is imposed with solarlong0
+        ! Case where the season is imposed with solarlong0
         zzz=real(90) ! could be revisited
      ENDIF
@@ -1764,8 +1764,8 @@
      IF (klon_glo==1) THEN
         CALL add_pbl_tend &
-          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
+             (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
      ELSE
         CALL add_phys_tend &
-          (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
+             (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,paprs,'vdf')
      ENDIF
      !--------------------------------------------------------------------
@@ -2369,44 +2369,44 @@
                    s_trig,s2,n2
            ENDIF
- 
-!Option pour re-activer l'ancien calcul de Ale_bl (iflag_trig_bl=2)
+
+           !Option pour re-activer l'ancien calcul de Ale_bl (iflag_trig_bl=2)
            IF (iflag_trig_bl.eq.1) then
 
-           !----Tirage al\'eatoire et calcul de ale_bl_trig
-           do i=1,klon
-              if ( (ale_bl_stat(i) .gt. abs(cin(i))+1.e-10) )  then
-                 proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
-                      (n2(i)*dtime/tau_trig(i))
-                 !        print *, 'proba_notrig(i) ',proba_notrig(i)
-                 if (random_notrig(i) .ge. proba_notrig(i)) then 
-                    ale_bl_trig(i)=ale_bl_stat(i)
+              !----Tirage al\'eatoire et calcul de ale_bl_trig
+              do i=1,klon
+                 if ( (ale_bl_stat(i) .gt. abs(cin(i))+1.e-10) )  then
+                    proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
+                         (n2(i)*dtime/tau_trig(i))
+                    !        print *, 'proba_notrig(i) ',proba_notrig(i)
+                    if (random_notrig(i) .ge. proba_notrig(i)) then 
+                       ale_bl_trig(i)=ale_bl_stat(i)
+                    else
+                       ale_bl_trig(i)=0.
+                    endif
                  else
+                    proba_notrig(i)=1.
+                    random_notrig(i)=0.
                     ale_bl_trig(i)=0.
                  endif
-              else
-                 proba_notrig(i)=1.
-                 random_notrig(i)=0.
-                 ale_bl_trig(i)=0.
-              endif
-           enddo
+              enddo
 
            ELSE IF (iflag_trig_bl.eq.2) then
 
-           do i=1,klon
-              if ( (Ale_bl(i) .gt. abs(cin(i))+1.e-10) )  then
-                 proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
-                      (n2(i)*dtime/tau_trig(i))
-                 !        print *, 'proba_notrig(i) ',proba_notrig(i)
-                 if (random_notrig(i) .ge. proba_notrig(i)) then 
-                    ale_bl_trig(i)=Ale_bl(i)
+              do i=1,klon
+                 if ( (Ale_bl(i) .gt. abs(cin(i))+1.e-10) )  then
+                    proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
+                         (n2(i)*dtime/tau_trig(i))
+                    !        print *, 'proba_notrig(i) ',proba_notrig(i)
+                    if (random_notrig(i) .ge. proba_notrig(i)) then 
+                       ale_bl_trig(i)=Ale_bl(i)
+                    else
+                       ale_bl_trig(i)=0.
+                    endif
                  else
+                    proba_notrig(i)=1.
+                    random_notrig(i)=0.
                     ale_bl_trig(i)=0.
                  endif
-              else
-                 proba_notrig(i)=1.
-                 random_notrig(i)=0.
-                 ale_bl_trig(i)=0.
-              endif
-           enddo
+              enddo
 
            ENDIF
@@ -2424,13 +2424,13 @@
 
            do i=1,klon
-!CR: alp probabiliste
-               if (ale_bl_trig(i).gt.0.) then
-                  alp_bl(i)=alp_bl(i)/(1.-min(proba_notrig(i),0.999))
-               endif
-           enddo        
-  
+              !CR: alp probabiliste
+              if (ale_bl_trig(i).gt.0.) then
+                 alp_bl(i)=alp_bl(i)/(1.-min(proba_notrig(i),0.999))
+              endif
+           enddo
+
         else if (iflag_clos_bl.eq.2) then
 
-!CR: alp calculee dans thermcell_main
+           !CR: alp calculee dans thermcell_main
            do i=1,klon
               alp_bl(i)=alp_bl_stat(i)
@@ -2469,7 +2469,7 @@
 
         do i=1,klon
-!           zmax_th(i)=pphi(i,lmax_th(i))/rg
-!CR:04/05/12:correction calcul zmax
-         zmax_th(i)=zmax0(i) 
+           !           zmax_th(i)=pphi(i,lmax_th(i))/rg
+           !CR:04/05/12:correction calcul zmax
+           zmax_th(i)=zmax0(i) 
         enddo
 
@@ -2500,9 +2500,9 @@
 
         if (iflag_thermals==0) then
-        ! Calling adjustment alone (but not the thermal plume model)
+           ! Calling adjustment alone (but not the thermal plume model)
            CALL ajsec_convV2(paprs, pplay, t_seri,q_seri &
                 , d_t_ajsb, d_q_ajsb)
         else if (iflag_thermals>0) then
-        ! Calling adjustment above the top of thermal plumes
+           ! Calling adjustment above the top of thermal plumes
            CALL ajsec(paprs, pplay, t_seri,q_seri,limbas &
                 , d_t_ajsb, d_q_ajsb)
@@ -2678,27 +2678,27 @@
         IF (.NOT. aerosol_couple) THEN
            IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-!
-             CALL readaerosol_optic( &
-             debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-             pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-             mass_solu_aero, mass_solu_aero_pi,  &
-             tau_aero, piz_aero, cg_aero,  &
-             tausum_aero, tau3d_aero)
-!
+              !
+              CALL readaerosol_optic( &
+                   debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                   pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                   mass_solu_aero, mass_solu_aero_pi,  &
+                   tau_aero, piz_aero, cg_aero,  &
+                   tausum_aero, tau3d_aero)
+              !
            ELSE                       ! RRTM radiation
-!
+              !
 #ifdef CPP_RRTM
-             CALL readaerosol_optic_rrtm( &
-             debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-             pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-             mass_solu_aero, mass_solu_aero_pi,  &
-             tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,  &
-             tausum_aero, tau3d_aero)
+              CALL readaerosol_optic_rrtm( &
+                   debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                   pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                   mass_solu_aero, mass_solu_aero_pi,  &
+                   tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm,  &
+                   tausum_aero, tau3d_aero)
 #else
 
-            abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-            call abort_gcm(modname,abort_message,1)
+              abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+              call abort_gcm(modname,abort_message,1)
 #endif
-!
+              !
            ENDIF
         ENDIF
@@ -2706,11 +2706,11 @@
         tausum_aero(:,:,:) = 0.
         IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-          tau_aero(:,:,:,:) = 0.
-          piz_aero(:,:,:,:) = 0.
-          cg_aero(:,:,:,:)  = 0.
+           tau_aero(:,:,:,:) = 0.
+           piz_aero(:,:,:,:) = 0.
+           cg_aero(:,:,:,:)  = 0.
         ELSE
-          tau_aero_rrtm(:,:,:,:)=0.0
-          piz_aero_rrtm(:,:,:,:)=0.0
-          cg_aero_rrtm(:,:,:,:)=0.0
+           tau_aero_rrtm(:,:,:,:)=0.0
+           piz_aero_rrtm(:,:,:,:)=0.0
+           cg_aero_rrtm(:,:,:,:)=0.0
         ENDIF
      ENDIF
@@ -2721,12 +2721,12 @@
         PRINT *,'appel a readaerosolstrat', mth_cur
         IF (iflag_rrtm.EQ.0) THEN
-         CALL readaerosolstrato(debut)
+           CALL readaerosolstrato(debut)
         ELSE
 #ifdef CPP_RRTM
-         CALL readaerosolstrato_rrtm(debut)
+           CALL readaerosolstrato_rrtm(debut)
 #else
 
-         abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-         call abort_gcm(modname,abort_message,1)
+           abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+           call abort_gcm(modname,abort_message,1)
 #endif
         ENDIF
@@ -2951,12 +2951,12 @@
      IF (iflag_rrtm.NE.0) THEN 
 #ifdef CPP_RRTM
-       IF (ok_cdnc.AND.NRADLP.NE.3) THEN
-         abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 pour ok_cdnc' 
-         call abort_gcm(modname,abort_message,1)
-       endif
+        IF (ok_cdnc.AND.NRADLP.NE.3) THEN
+           abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 pour ok_cdnc' 
+           call abort_gcm(modname,abort_message,1)
+        endif
 #else
 
-       abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-       call abort_gcm(modname,abort_message,1)
+        abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+        call abort_gcm(modname,abort_message,1)
 #endif
      ENDIF