Index: LMDZ5/trunk/arch/arch-CICLADifort-seq.fcm
===================================================================
--- LMDZ5/trunk/arch/arch-CICLADifort-seq.fcm	(revision 2123)
+++ 	(revision )
@@ -1,15 +1,0 @@
-%COMPILER            ifort
-%LINK                ifort
-%AR                  ar
-%MAKE                make
-%FPP_FLAGS           -P -traditional
-%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM FFT_FFTW
-%BASE_FFLAGS         -real-size 64 -ip -mkl=sequential -fp-model precise -align common -mcmodel=large
-%PROD_FFLAGS         -O2
-%DEV_FFLAGS          -O2
-%DEBUG_FFLAGS        -g -no-ftz -check -traceback -ftrapuv -fp-stack-check
-%MPI_FFLAGS          
-%OMP_FFLAGS          
-%BASE_LD             -mkl=sequential 
-%MPI_LD              -lmkl_core -lfftw3
-%OMP_LD              
Index: LMDZ5/trunk/arch/arch-CICLADifort-seq.path
===================================================================
--- LMDZ5/trunk/arch/arch-CICLADifort-seq.path	(revision 2123)
+++ 	(revision )
@@ -1,10 +1,0 @@
-NETCDF_LIBDIR="-L/opt/netcdf/ifort/lib -lnetcdf"
-NETCDF_INCDIR=-I/opt/netcdf/ifort/include
-IOIPSL_INCDIR=/home/spiga/IOIPSL_SVN/modipsl/lib
-IOIPSL_LIBDIR=/home/spiga/IOIPSL_SVN/modipsl/lib
-ORCH_INCDIR=$LMDGCM/../../lib
-ORCH_LIBDIR=$LMDGCM/../../lib
-OASIS_INCDIR=$LMDGCM/../../prism/SX/build/lib/psmile.$couple
-OASIS_LIBDIR=$LMDGCM/../../prism/SX/lib
-INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
-INCA_INCDIR=$LMDGCM/../INCA3/config/lib
Index: LMDZ5/trunk/arch/arch-CICLADifort.fcm
===================================================================
--- LMDZ5/trunk/arch/arch-CICLADifort.fcm	(revision 2123)
+++ 	(revision )
@@ -1,15 +1,0 @@
-%COMPILER            /usr/lib64/openmpi/1.4.3-ifort/bin/mpif90
-%LINK                /usr/lib64/openmpi/1.4.3-ifort/bin/mpif90
-%AR                  ar
-%MAKE                make
-%FPP_FLAGS           -P -traditional
-%FPP_DEF             NC_DOUBLE
-%BASE_FFLAGS         -real-size 64 -ip -mkl=parallel -fp-model precise -align common -mcmodel=large 
-%PROD_FFLAGS         -O2
-%DEV_FFLAGS          -O2
-%DEBUG_FFLAGS        -fpe0 -g -no-ftz -check -traceback -ftrapuv -fp-stack-check
-%MPI_FFLAGS          -I/usr/lib64/openmpi/1.4.3-ifort/include
-%OMP_FFLAGS          
-%BASE_LD             -mkl=parallel
-%MPI_LD              -L/usr/lib64/openmpi/1.4.3-ifort/lib -lmpi -lmkl_core 
-%OMP_LD              
Index: LMDZ5/trunk/arch/arch-CICLADifort.path
===================================================================
--- LMDZ5/trunk/arch/arch-CICLADifort.path	(revision 2123)
+++ 	(revision )
@@ -1,10 +1,0 @@
-NETCDF_LIBDIR="-L/opt/netcdf/ifort/lib -lnetcdf"
-NETCDF_INCDIR=-I/opt/netcdf/ifort/include
-IOIPSL_INCDIR=/home/spiga/IOIPSL_SVN/modipsl/lib
-IOIPSL_LIBDIR=/home/spiga/IOIPSL_SVN/modipsl/lib
-ORCH_INCDIR=$LMDGCM/../../lib
-ORCH_LIBDIR=$LMDGCM/../../lib
-OASIS_INCDIR=$LMDGCM/../../prism/SX/build/lib/psmile.$couple
-OASIS_LIBDIR=$LMDGCM/../../prism/SX/lib
-INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
-INCA_INCDIR=$LMDGCM/../INCA3/config/lib
Index: LMDZ5/trunk/arch/arch-ifort_ciclad.fcm
===================================================================
--- LMDZ5/trunk/arch/arch-ifort_ciclad.fcm	(revision 2130)
+++ LMDZ5/trunk/arch/arch-ifort_ciclad.fcm	(revision 2130)
@@ -0,0 +1,15 @@
+%COMPILER            /usr/lib64/openmpi/1.4.5-ifort/bin/mpif90
+%LINK                /usr/lib64/openmpi/1.4.5-ifort/bin/mpif90
+%AR                  ar
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             NC_DOUBLE
+%BASE_FFLAGS         -real-size 64 -ip -fp-model precise -align all -mcmodel=large -auto
+%PROD_FFLAGS         -O2 -ip
+%DEV_FFLAGS          -p -g -O1 -fpe0 -traceback
+%DEBUG_FFLAGS        -p -g -O0 -fpe-all=0 -traceback -ftrapuv -fp-stack-check -check all -debug
+%MPI_FFLAGS          -I/usr/lib64/openmpi/1.4.5-ifort/include
+%OMP_FFLAGS          -openmp
+%BASE_LD             -Wl,-rpath=/opt/netcdf42/ifort/lib
+%MPI_LD              -L/usr/lib64/openmpi/1.4.5-ifort/lib -lmpi -lmkl_core 
+%OMP_LD              -openmp
Index: LMDZ5/trunk/arch/arch-ifort_ciclad.path
===================================================================
--- LMDZ5/trunk/arch/arch-ifort_ciclad.path	(revision 2130)
+++ LMDZ5/trunk/arch/arch-ifort_ciclad.path	(revision 2130)
@@ -0,0 +1,10 @@
+NETCDF_LIBDIR="-L/opt/netcdf42/ifort/lib -lnetcdf -lnetcdff"
+NETCDF_INCDIR=-I/opt/netcdf42/ifort/include
+IOIPSL_INCDIR=$LMDGCM/../../lib
+IOIPSL_LIBDIR=$LMDGCM/../../lib
+ORCH_INCDIR=$LMDGCM/../../lib
+ORCH_LIBDIR=$LMDGCM/../../lib
+OASIS_INCDIR=$LMDGCM/../../prism/SX/build/lib/psmile.$couple
+OASIS_LIBDIR=$LMDGCM/../../prism/SX/lib
+INCA_LIBDIR=$LMDGCM/../INCA3/config/lib
+INCA_INCDIR=$LMDGCM/../INCA3/config/lib